/****************************************************************************
 Copyright (c) 2017-2018 Xiamen Yaji Software Co., Ltd.

 http://www.cocos2d-x.org

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/



#include "HelloWorldScene.h"
#include "SimpleAudioEngine.h"
#include "SimpleAudioEngine.h"
#include "cocos2d.h"
#define MOUSE_BUTTON_LEFT       0
#define MOUSE_BUTTON_RIGHT      1
#define MOUSE_BUTTON_MIDDLE     2
using namespace cocos2d;
using namespace CocosDenshion;

USING_NS_CC;

Scene* HelloWorld::createScene()
{
	return HelloWorld::create();
}
static void problemLoading(const char* filename)
{
	printf("Error while loading: %s\n", filename);
	printf("Depending on how you compiled you might have to add 'Resources/' in front of filenames in HelloWorldScene.cpp\n");
}
bool HelloWorld::init()
{
	if (!Scene::init())
	{
		return false;
	}
	auto visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	auto label = Label::createWithTTF("Hello World", "fonts/Marker Felt.ttf", 24);
	if (label == nullptr)
	{
		problemLoading("'fonts/Marker Felt.ttf'");
	}
	else
	{
		label->setPosition(Vec2(origin.x + visibleSize.width / 2,
			origin.y + visibleSize.height - label->getContentSize().height));
		this->addChild(label, 1);
	}
	auto sprite = Sprite::create("HelloWorld.png");
	if (sprite == nullptr)
	{
		problemLoading("'HelloWorld.png'");
	}
	else
	{
		sprite->setPosition(Vec2(visibleSize.width / 2 + origin.x, visibleSize.height / 2 + origin.y));
		this->addChild(sprite, 0);
	}

	node2=Sprite::create("ty.png");
	node2->setPosition(Vec2(200,200));
	this->addChild(node2);

	auto _mouseListener=EventListenerMouse::create();
	_mouseListener->onMouseDown=CC_CALLBACK_1(HelloWorld::onMouseDown,this);
	_mouseListener->onMouseUp=CC_CALLBACK_1(HelloWorld::onMouseUp,this);
	_eventDispatcher->addEventListenerWithSceneGraphPriority(_mouseListener,this);
	SimpleAudioEngine::getInstance()->playBackgroundMusic("yingyue.mp3",true);

	this->schedule(CC_CALLBACK_1(HelloWorld::popScene,this),2.1f,"aaa");//ʱscheduleUpdate()ͬʱʹ
	return true;
}




void HelloWorld::onMouseDown(Event* event){
		Sprite* node3=Sprite::create("ty.png");
		node3->setPosition(node2->getPosition());
		this->addChild(node3);
		SimpleAudioEngine::getInstance()->playEffect("yingxiao.mp3", false, 1.0, 1.0, 1.0);
		this->mouseDownEvent=(EventMouse*)event;
		auto moveTo = MoveTo::create(1, Vec2(mouseDownEvent->getCursorX(),mouseDownEvent->getCursorY()));
		node3->runAction(moveTo);
		auto pDelayTime=DelayTime::create(0.2f);
		node3->runAction(pDelayTime);
}

void HelloWorld::onMouseUp(Event* event){
	mouseDownEvent=nullptr;
}

void HelloWorld::popScene(float t)
{
	if(mouseDownEvent){
		SimpleAudioEngine::getInstance()->playEffect("yingxiao.mp3", false, 1.0, 1.0, 1.0);
		Sprite* node3=Sprite::create("ty.png");
		node3->setPosition(node2->getPosition());
		this->addChild(node3);
		auto moveTo = MoveTo::create(1, Vec2(mouseDownEvent->getCursorX(),mouseDownEvent->getCursorY()));
		node3->runAction(moveTo);
		auto pDelayTime=DelayTime::create(0.2f);
		node3->runAction(pDelayTime);
	   }
}








